#include <MacTypes.h>
#include <CFString.h>
#include "main.h"

FSRef URLToFSRef (char *path, Boolean isDirectory) {
   CFStringRef sr; CFURLRef ur; FSRef r;
 
   sr = CFStringCreateWithCString(NULL, path,
      CFStringGetSystemEncoding());
   ur = CFURLCreateWithFileSystemPath(NULL,
      sr, kCFURLPOSIXPathStyle, isDirectory);
   if (ur != NULL)
      CFURLGetFSRef(ur, &r);

   return r;
}

char *FSRefToURL(FSRef *fspath) {
   CFURLRef ur; CFStringRef sr;
   char *rp;

   ur = CFURLCreateFromFSRef(NULL, fspath);
   sr = CFURLCopyFileSystemPath(ur, kCFURLPOSIXPathStyle);
   rp = CFStringGetCStringPtr(sr, CFStringGetSystemEncoding());

   if (rp == NULL) {
      rp = malloc(MAXPATHLEN);
      CFStringGetCString(sr, rp, MAXPATHLEN, CFStringGetSystemEncoding());
   }

   return rp;
}
